Package org.apache.sling.feature.cpconverter.index

## Interface IndexManager

All Known Implementing Classes:
  `DefaultIndexManager`

    public interface IndexManager

Point of entry for logic related to handling Oak indexes

See Also:
  Oak-Run indexing

### Field Summary

Fields
`static String` `EXTENSION_NAME`

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `addRepoinitExtension​(FeaturesManager features)` Records the Oak index data using the features manager
`@NotNull IndexDefinitions` `getIndexes()` Returns the index definitions managed by this instance
`void` `reset()` Resets the internal state

### Field Detail

#### EXTENSION_NAME

    static final String EXTENSION_NAME

See Also:
  Constant Field Values

### Method Detail

#### getIndexes

    @NotNull
    @NotNull IndexDefinitions getIndexes()

Returns the index definitions managed by this instance

The returned object may be used to record data discovered about oak indexes

Returns:
  the index definitions

#### addRepoinitExtension

    void addRepoinitExtension​(FeaturesManager features)
                       throws IOException,
                              ConverterException

Records the Oak index data using the features manager

The index definitions will be recoreded as a JSON repoinit extension named "oak-index-definitions" .

Parameters:
  `features` -
Throws:
  `IOException`
  `ConverterException`

#### reset

    void reset()

Resets the internal state